// C Source File
// Created 4/7/01; 4:48:49 PM

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents
#define TI89_VERSION

#include <tigcclib.h>         // Include All Header Files
#include "textedit.h"

//short _ti92plus;              // Produce .9XZ File
short _ti89;                  // Produce .89Z File

// Main Function
void _main(void)
{
	// test of file I/O functions.
	
	ESI argptr;
	char* filename;
	FILE *f;
	char *s;
	
	InitArgPtr(argptr);
	if(ArgCount() != 1) return;
	if(GetArgType(argptr) != STR_TAG) return;
	filename = GetStrnArg(argptr);
	
	f = fopen(filename, "r");
	s = malloc(CHAR_COUNT + 1);
	if(s == NULL) return;

	OSEnableBreak();
	FontSetSys(F_6x8);
	while(!feof(f) && !OSCheckBreak()) {
		clrscr();
		displayWordWrapped(f, s);
		ngetchx();
	}

	OSClearBreak();

	fclose(f);
	free(s);
}
