// C Header File
// Created 4/9/01; 1:48:02 AM

#include <stdio.h>

#ifdef TI89_VERSION
#define CHAR_COUNT 26
#define LINE_COUNT 12
#else
#define CHAR_COUNT 39
#define LINE_COUNT 16
#endif
#define CHAR_WIDTH 6
#define CHAR_HEIGHT 8
/* Text editor support functions. */

/*
 * Displays text from a FILE in word-wrapped form.  Buffer pointed to by
 * s must be CHAR_COUNT + 1 characters.
 */
void displayWordWrapped(FILE *f, char *s) {
	// test of file I/O functions.
	
	char *scan;
	char temp;
	unsigned long linelen = 0;
	unsigned int chars=CHAR_COUNT; // characters remaining in line
	unsigned int line = 0; // current line;
	int breakline = 0;
	
	unsigned int xpos = 0, ypos = 0; // XY character location
	
/*	clrscr();
	FontSetSys(F_6x8);*/
	while(!feof(f) && line < LINE_COUNT) {
		fgets(s, chars+1, f);
		linelen = strlen(s);
		scan = s + linelen - 1;
		breakline = (*scan == 10);
		if(breakline) *scan = 0;
		if(linelen<chars) {
			// print line as-is, it'll fit.  Lose CR.
			//*(s + linelen - 1) = 0;
			DrawStr(xpos, ypos, s, A_REPLACE);
			xpos = 0; ypos += CHAR_HEIGHT;
			chars = CHAR_COUNT;
			line++;
		} else {
			// get pointer to last character in line.
//			scan = s + linelen - 1;
			//if(*scan == 13) *scan = 0; // erase CR if present
			// walk backwards to find a breaking character.
			while(*scan != ' ' && *scan != '-' && scan > s) {
				scan--;
			}
			// now we've either got a breaking character,
			// or there wasn't one in this line.
			if(scan == s) {
				// no breaking character in this line.
				// print it as-is.
				DrawStr(xpos, ypos, s, A_REPLACE);
				xpos = 0; ypos += CHAR_HEIGHT;
				chars = CHAR_COUNT;
				line++;
			} else {
				if(*scan == ' ') {
					// break at space.  DO NOT print space on next line.
					// skip multiple spaces
					while(*(scan - 1) == ' ') scan--;
					*scan = 0;
					DrawStr(xpos, ypos, s, A_REPLACE);
					xpos = 0; ypos += CHAR_HEIGHT;
					scan++;
					while(*scan == ' ') scan++; // skip multiple spaces.
				} else if(*scan == '-') {
					// break at hyphen.  DO print hyphen on same line.
					scan++;
					temp = *scan;
					*scan = 0;
					DrawStr(xpos, ypos, s, A_REPLACE);
					xpos = 0; ypos += CHAR_HEIGHT;
					*scan = temp;
				}
				line++;
				linelen -= scan - s;
				if(line < LINE_COUNT) {
					DrawStr(xpos, ypos, scan, A_REPLACE);
					if(breakline) {
						xpos = 0; ypos += CHAR_HEIGHT; chars = CHAR_COUNT; line++;
					} else {
						xpos = linelen * CHAR_WIDTH;
						chars = CHAR_COUNT - linelen;
					}
				} else {
					fseek(f, -linelen, SEEK_CUR);
				}
			}
		}
	}
	
}
